## Constructing and Navigating a Course Catalog##
#################################################

# Combining/concatenating elements to a vector using the function c().
course_title <- c("Roman fortification systems", "Gothic mysticism", 
                  "Popper reading class", "Logarithms", "Intro to Forestry", 
                  "Toxic plants", "Aristotle and his impact" ) # character vector

rating <- c(20, 15, 69, 69, 99, 87, 34 ) # numeric vector

taught_online <- c(TRUE, FALSE, FALSE, TRUE, TRUE, FALSE, TRUE) # boolean vector

study_program <- c("Humanities", "Humanities", "Humanities", "Math", "Life Sciences", "Life Sciences", "Humanities" ) # character vector

# print study_program in the console
 
------

# Make it a table: Data frame
# Use function data.frame() to create a data frame called courses_dataframe
courses_dataframe <- ------(course_title, taught_online, rating, study_program) 

# Explore its structure
---(courses_dataframe)

# Maximum rating
# Use function max() to compute the maximum value of a numeric vector
---(rating)
---(study_program) # heh? Max alphabetical order with characters!


# What does this function do? Just run it. 
# 
toupper(max(c(1,3,"z")))

weird_mix <- c(1,3,"z")
weird_mix
str(weird_mix)

# Now that we have the data frame, let us get rid of the vectors
objects()
rm("course_title")

rm("rating", "study_program", "taught_online")


# Course with Maximum rating
# When you know where the name of that course is located in the data frame: 


# on the 6th row, 1st column:

------

# Whole row (show all columns)

-----

# The whole rating column 

----


# Subset with various conditions - when you don't know their positions
# Use logical operators ==, !=, >, <, >=, <=

# Which course (title) has rating above 70?  

----  

# Are they taught online?

---- # combine the conditions with &

# Which course has the best rating?


# Save the "rating" column into a variable called "var1"

# If you used the $ sign to create var1, use the square bracket now to create var2.

# If you used the square bracket to create var1, use the $ sign now to create var2.

# Call function str() on var1, var2, respectively, to find out what data structures they are. 
# You could of course immediately see this in the Environment quadrant.  


###
#remove the dataframe from your working environment
rm(courses_dataframe)

# missing values NA (now we ignore some more value types like that)

my_vector <- c(1,2,3,NA, 100)
max(my_vector)
?max #look at the bottom right quadrant, help opens for you 

max(my_vector, na.rm = TRUE)


## Some more stuff about vectors

c(2,3,4) + c(1,1,1) # what did you expect as output? 

c(c(2,3,4), c(1,1,1))

#Let all this sink in with you at DataCamp, Intro to R: Vectors, Data frames
